Attribute VB_Name = "MainModule"
'Dieser Source stammt von http://www.vb-fun.de und kann frei
'in EIGENEN (auch in EIGENEN kommerziellen) Projekten verwendet
'werden. Er darf NICHT auf anderen Webseiten oder Foren ohne
'Quellenangabe verffentlicht werden (siehe hierzu auch die
'Hinweise unter "Urheber- und Kennzeichenrecht" im Impressum).
'Fr eventuelle Schden wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source-Code !

Option Explicit

Public Running As Boolean

Public Enum CONST_MOVES
    MOVE_NONE = 0
    MOVE_FORE = 1
    MOVE_RIGHT = 2
    MOVE_BACK = 4
    MOVE_LEFT = 8
    MOVE_TURN = 16
End Enum

Public Type strcPlayer
    x       As Single
    y       As Single
    z       As Single
    AngleY  As Single
    AngleX  As Single
    Move    As Integer
    TurnHor As Long
    TurnVer As Long
End Type
Public PLAYER As strcPlayer

'API-Funktionen
Public Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

Public Sub Main()

    frmMain.Show
    frmMain.Refresh
    
    MathModule.SetPI
    With PLAYER
        .x = 0: .y = 6: .z = 0
        .AngleY = 0#: .Move = MOVE_NONE: .TurnHor = 0#: .TurnVer = 0#: .AngleX = 0#
    End With
    
    InitDirectDraw frmMain.hWnd, False
    InitDirect3D
    InitDInput frmMain.hWnd
    BitmapModule.Load_BMP
    BackBuffer.SetForeColor vbBlack
    BackBuffer.SetFont frmMain.Font
        
    DX7.IdentityMatrix myYMatrix
    DX7.IdentityMatrix myXMatrix
    DX7.IdentityMatrix myTranslateMatrix
    DX7.IdentityMatrix myNewMatrix
    
    VertexModule.SetVertex
    
    XFileModule.XFile_Load "vbfun.x"
    
    Running = True
    Do
        
        PLAYER.TurnHor = 0#
        PLAYER.TurnVer = 0#
        PLAYER.Move = MOVE_NONE
        DIModule.CheckInput
        DIModule.CheckMouse
        With PLAYER
            'y-Achse rotieren
            If .TurnHor <> 0 Then
                .AngleY = .AngleY + (.TurnHor / 5)
                .Move = .Move Or MOVE_TURN
                If .AngleY < 0 Then
                    .AngleY = 360 + .AngleY
                ElseIf .AngleY > 360 Then
                    .AngleY = .AngleY - 360
                End If
            End If
            'x-Achse rotieren
            If .TurnVer <> 0 Then
                .AngleX = .AngleX + (.TurnVer / 10)
                If .AngleX > 50 Then .AngleX = 50
                If .AngleX < -50 Then .AngleX = -50
                .Move = .Move Or MOVE_TURN
            End If
        End With
        'hat sich der Spieler berhaupt bewegt ?
        If PLAYER.Move <> MOVE_NONE Then
            'neue Spielerposition berechnen
            CalculateViewStartPos
            'Matrix-Ursprung auf Spielerposition setzen
            TranslateMatrix myTranslateMatrix, RVector(PLAYER.x * -1, PLAYER.y * -1, PLAYER.z * -1)
            'Matrix Y-Rotation
            RotateYMatrix myYMatrix, PLAYER.AngleY * PI / 180
            'Matrix X-Rotation
            RotateXMatrix myXMatrix, PLAYER.AngleX * PI / 180
            'Matrizen zusammenfhren
            myNewMatrix = RetMatrixMult(myTranslateMatrix, myYMatrix)
            View3DMatrix = RetMatrixMult(myNewMatrix, myXMatrix)
            'Transformation der ViewPortMatrix durchfhren
            Device.SetTransform D3DTRANSFORMSTATE_VIEW, View3DMatrix
        End If
        
        'Szene rendern
        Render3D
        
        BackBuffer.BltFast 394, 294, bmpCross, recCross, _
            DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
        
        BackBuffer.DrawText 10, 10, "DirectDraw und Direct3D - XFile", False
        BackBuffer.DrawText 10, 30, "<Esc> beendet das Programm", False
        BackBuffer.DrawText 10, 50, "Bewegen: W A S D - Tasten", False
        BackBuffer.DrawText 10, 70, "Drehen: Maus", False
        PrimarySurface.Flip BackBuffer, DDFLIP_WAIT
        DoEvents
    Loop While Running
    
    BitmapModule.Terminate_BMP
    TerminateDInput
    TerminateDirectX frmMain.hWnd
    Unload frmMain
    End

End Sub

Public Sub Render3D()
    Dim i As Integer
    Device.Clear 1, ClearRec(), D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, DX7.CreateColorRGBA(0.04, 0.04, 0.07, 1), 1, 0
    Device.BeginScene
    Call Device.SetTexture(0, texTextur)
    'TexturKoordinaten ausserhalb der Textur werden nicht gespiegelt
    Call Device.SetTextureStageState(0, D3DTSS_ADDRESS, D3DTADDRESS_WRAP)
    'Bilinearen Texturfilter verwenden damit die Textur nicht so grob gerastert wird
    Call Device.SetTextureStageState(0, D3DTSS_MAGFILTER, D3DTFG_LINEAR)
    Call Device.DrawPrimitive(D3DPT_TRIANGLELIST, D3DFVF_LVERTEX, vxSkyBox(0), 36, D3DDP_WAIT)
    'alle Gruppen (Meshes) aus dem XFile rendern
    For i = 0 To GroupCount - 1
        Call Device.SetTexture(0, Groups(i).Texture)
        Call Device.SetTextureStageState(0, D3DTSS_ADDRESS, D3DTADDRESS_WRAP)
        Call Device.SetTextureStageState(0, D3DTSS_MAGFILTER, D3DTFG_LINEAR)
        Call Device.DrawPrimitive(D3DPT_TRIANGLELIST, D3DFVF_LVERTEX, Groups(i).RenderVertexList(0), UBound(Groups(i).RenderVertexList) + 1, D3DDP_WAIT)
    Next
    Device.EndScene
End Sub

Private Sub CalculateViewStartPos()
    Dim px As Single
    Dim pz As Single
    If (PLAYER.Move And MOVE_FORE) = MOVE_FORE Then
        px = Sin((PLAYER.AngleY * (PI / 180))) * 2
        pz = Cos((PLAYER.AngleY * (PI / 180))) * 2
        PLAYER.x = PLAYER.x + px
        PLAYER.z = PLAYER.z + pz
    End If
    If (PLAYER.Move And MOVE_BACK) = MOVE_BACK Then
        px = -Sin((PLAYER.AngleY * (PI / 180))) * 2
        pz = -Cos((PLAYER.AngleY * (PI / 180))) * 2
        PLAYER.x = PLAYER.x + px
        PLAYER.z = PLAYER.z + pz
    End If
    If (PLAYER.Move And MOVE_LEFT) = MOVE_LEFT Then
        px = Sin((PLAYER.AngleY * (PI / 180))) * 2
        pz = -Cos((PLAYER.AngleY * (PI / 180))) * 2
        PLAYER.x = PLAYER.x - pz * -1
        PLAYER.z = PLAYER.z - px * -1
    End If
    If (PLAYER.Move And MOVE_RIGHT) = MOVE_RIGHT Then
        px = Sin((PLAYER.AngleY * (PI / 180))) * 2
        pz = -Cos((PLAYER.AngleY * (PI / 180))) * 2
        PLAYER.x = PLAYER.x + pz * -1
        PLAYER.z = PLAYER.z + px * -1
    End If
End Sub

